package com.eactive.eai.batch.job.jobItem.fiusc;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.common.StringUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_FIUSC_0315 extends DefaultTelegram implements TelegramService
{
    private int SEND_LENGTH;            //길이 필드를 제외한 전문의 총길이
    private int REAL_SEND_LENGTH;       //실제 송신할 전문의 총길이( SEND_LENGTH + 길이필드 길이)

    private Properties       telegramInfo;
    private FileOutputStream fout;
    private String           RTN_CD;

    /**
     * 생성자
     */
    public SEND_FIUSC_0315() {
        //파일 종료 응답
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = compareSeqNSize();
            if (!result) return false;

            result = calculateSendLength();
            if (!result) return false;

            int i = -1;
            //전문송신  전체 Byte 수
            compileField(++i, ""+REAL_SEND_LENGTH, this.al_FieldProps[i]);
            
            // Transaction Code
            compileField(++i, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[i]);

            // 시스템명칭 (FIU)
            compileField(++i, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[i]);
            
            // 참가기관코드
            compileField(++i, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[i]);
            
            //사용자ID
            byte[] userId = new byte[20];
            for ( int inx = 0; inx < userId.length; inx++ ){
            	userId[inx] = ' ';
            }
            
            System.arraycopy(batchDoc.getBatchMsg().getHeader().getUserID().getBytes(), 0, userId, 0,
            		Math.min(batchDoc.getBatchMsg().getHeader().getUserID().getBytes().length, 20));

            al_Field.set(++i, userId);
            
            //전문종별코드.
            compileField(++i, this.getFldTelegramType()+ this.getFldOpCode() + "0", this.al_FieldProps[i]);
            
            //송수신 FLAG : 전문 발생 기관을 구분하여  아래의 값을 SET한다.
            compileField(++i, getFldTrClass(), this.al_FieldProps[i]);

            //기관구분
            compileField(++i, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[i]);

            //계속여부 
    		compileField(++i, "Y", this.al_FieldProps[i]);
            
            //응답코드
            compileField(++i, getSendResponseCode(), this.al_FieldProps[i]);
            // 여기 까지 공통부

            //결과
            compileField(++i, RTN_CD, this.al_FieldProps[i]);

            //시퀀스
            compileField(++i, ""+batchDoc.getBatchMsg().getBody().getSeqNum(), this.al_FieldProps[i]);

            //수신크기
            compileField(++i, ""+batchDoc.getBatchMsg().getBody().getCurFileSize(), this.al_FieldProps[i]);

            //종료 일시
            compileField(++i, TelegramKeys.getYYYYMMddHHmmss(), this.al_FieldProps[i]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
                
            if ( fout != null ){
                fout.close();
            }
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));
//            batchDoc.getBatchMsg().getHeader().setBizCode(new String((byte[])this.al_Field.get(2)));
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;

            //BATCH작업구분코드 (processCode)에 따른 프로퍼티 정보 가져오기
            telegramInfo = getTelegramInfo();

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            logger.error(e.getMessage(),e);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }

        return true;
    }

    private boolean compareSeqNSize() {
        try {
            int  seq_no   = this.batchDoc.getBatchMsg().getBody().getSeqNum();
            long cur_size = this.batchDoc.getBatchMsg().getBody().getCurFileSize();
        	
            // 이전 전문에서 저장한 전문 내용을 꺼내어 본다. 17 자리라고 가정
            String recvTelegramBody = new String(batchDoc.getBatchMsg().getTelegramBody());
            int  recv_seq_no   = Integer.parseInt(recvTelegramBody.substring(0, 7));
            long recv_cur_size = Integer.parseInt(recvTelegramBody.substring(7,17));
            
            if ( cur_size == recv_cur_size){
            	if ( seq_no == recv_seq_no ){
            		RTN_CD = "00";
            	} else {
            		RTN_CD = "01";
            	}
            } else {
            	if ( seq_no == recv_seq_no ){
            		RTN_CD = "10";
            	} else {
            		RTN_CD = "11";
            	}
            }
            
            if (RTN_CD.equals("00")) {
                //  수신 파일 관련 처리
                String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
                String fileNm  = batchDoc.getBatchMsg().getHeader().getFileName();
                if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                    fileDir = fileDir.trim() + this.getSeparator();
                }
                String fileName = fileDir + fileNm.trim();

                File rcvRealFile = new File( fileName );
                File rcvArchFile = new File( StringUtil.realToArchDir(fileName) );

                if (rcvRealFile.exists()) {
                	// DB로그에 남길 파일 헤더,트레일러 내용 설정
                	super.setFileHeaderAndTrailer(rcvRealFile);
                	
                	// DB로그에 남길 파일 사이즈 설정
                	batchDoc.getBatchMsg().getHeader().setFileSize(rcvRealFile.length());
                	
                	// 수신 Real 디렉토리 -> Arch 디렉토리로 파일 이동 (파일명 변경 안한고 동일 파일명 존재시 Overwrite)
                	logger.info("{} >>>>> 수신 파일을 수신 Real 디렉토리 -> 수신 Arch 디렉토리로 이동.....", logHeader);
                	
                	if (rcvArchFile.exists()) rcvArchFile.delete(); // 기존에 수신된 동일한 파일이 있으면 삭제
//                	boolean isSuccessMoveFile = moveRealFile(rcvRealFile,rcvArchFile);
                	boolean isSuccessMoveFile = rcvRealFile.renameTo(rcvArchFile);
                	if (!isSuccessMoveFile) {
                		String errMsg = ExceptionUtil.getErrorCode("UNDEFINED_CD", new String[] {rcvRealFile.getAbsolutePath(), rcvArchFile.getAbsolutePath()});
                		batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                		//수신 파일을 수신 Real 디렉토리에서 수신 Arch 디렉로 이동시 오류가 발생하였습니다. [Real Path: {1}] [Arch Path: {2}]
                		
                		RTN_CD = "99";
                	}
                	
            		// 수신 Root 디렉토리에 동일 파일명의 0 byte 의 Dummy 파일 생성
            		logger.info("{} >>>>> 수신 파일과 동일 파일명의 0 Byte 파일을 수신 Root 디렉토리에 생성......(호스트에  자동 송신하도록 수신 File Event 발생)", logHeader);
            		try {
            			File rcvRootFile = new File( StringUtil.realToRootDir(fileName) );
            			rcvRootFile.createNewFile();
            		} catch (Exception ex) {
            			String errMsg = ExceptionUtil.getErrorCode(ex, "BECEAIFJI031", new String[] { StringUtil.realToRootDir(fileName) });
            			batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);	//수신 Root 디렉토리에 0 Byte 파일을 생성할 수 없습니다. [Path: {1}]
            			return false;
            		}
                	
                	// DB로그에 남길 변경 파일명 설정 (파일명 변경 안함)
                	batchDoc.getBatchMsg().getHeader().setRenamedFileName(fileNm);
                	
                	// 수신 파일 End DB로그
                	LogUtil.setLogFileEnd(batchDoc);
                }
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI027";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
        return true;
    }

    private boolean moveRealFile(File rcvRealFile, File rcvArchFile) {
    	
    	boolean result = false;
    	
        //InputStream ios = null;// 20250910 obl
        InputStream ioss = null;
        FileOutputStream fos  = null;
        try {
        	
        	byte[] realFileInfo = new byte[(int)rcvRealFile.length()];
        	ioss = new FileInputStream(rcvRealFile);
        	ioss.read(realFileInfo);
        	ioss.close();
        	ioss = null;
        	
        	fos = new FileOutputStream(rcvArchFile);
        	fos.write(realFileInfo);
        	
        	if (rcvArchFile.exists() && rcvArchFile.length() > 0) {
        		result = rcvRealFile.delete();
        	}
        } catch (IOException e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            
		} finally {
        	try {
        		//if (ios != null) ios.close();
        		if (ioss != null) ioss.close();
        		if (fos != null) fos.close();
        	} catch (IOException ioe) {
        		logger.debug(ioe.getMessage(),ioe);
        	}
        }
    	
    	return result;
    }
    
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
    	String telegramNo = super.getFieldValueString(5);
    	if ( telegramNo.length() < 8 ) return "";
		return telegramNo.substring(0,3) + telegramNo.substring(6,7);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(9);
    }

}
